/***************************************************************************
 *   Copyright (C) 2007 by David Torres   *
 *   aiken669@gmail.com   *
 ***************************************************************************/


#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <iostream>
#include <stdlib.h>
#include "SDL.h"

#include "ow_board.h"
#include "ow_player.h"
#include "ow_game.h"

using namespace std;
ow_game		*owgame;

void commandline_handler_wrapper(char *command);
void commandline_handler_null(char *command);
char **commandline_completion_handler(const char *text, int start, int end);
char *commandline_command_generator(const char *text, int state);
int commandline_savegames_filter(char **matches);

int main(int argc, char *argv[])
{
	Uint8 *keys;
	int mouse_x, mouse_y;
	ow_move	selected_cell;
	parsed_command pcommand;
	string coordname;

	owgame	= new ow_game();
	owgame->show_version();
	cout << "Type 'h' at any moment for help." << endl;
	owgame->ow_setcommandlinehandlers(commandline_handler_wrapper,commandline_handler_null,commandline_completion_handler,commandline_command_generator,commandline_savegames_filter);


    // MAIN GAME Loop
	owgame->rungame();
	while (owgame->gamerunning()) {
		owgame->draw_gfx(); // if gfxboard is not hidden, draw it.
		if (owgame->gamecreated()) {
			if (owgame->gamesettingup()) {
				// Setting up the board
				if(owgame->MouseLeftButtonClicked(&mouse_x,&mouse_y)) { //PUT SEEDS
					selected_cell = owgame->seleccionarcelda_bycoord(mouse_x,mouse_y);
					coordname = owgame->ow_commandline_translate_coord2name(selected_cell.boardside, selected_cell.x, selected_cell.y);
					cout << "put " << coordname << " 1" << endl;	pcommand.param1 = coordname; pcommand.param2 = "1";
					owgame->ow_commandline_setupboard_put(&pcommand);
				}
				if(owgame->MouseRightButtonClicked(&mouse_x,&mouse_y)) { //TAKE SEEDS
					selected_cell = owgame->seleccionarcelda_bycoord(mouse_x,mouse_y);
					coordname = owgame->ow_commandline_translate_coord2name(selected_cell.boardside, selected_cell.x, selected_cell.y);
					cout << "take " << coordname << " 1" << endl;	pcommand.param1 = coordname; pcommand.param2 = "1";
					owgame->ow_commandline_setupboard_take(&pcommand);
				}
				owgame->board_update_status();
			} else {
				// else if settingup
				if (owgame->gameplaying()) {
//					if (!owgame->checkgamewon()) {
					owgame->board_update_status();
					if (owgame->selplayer_endofturn() && owgame->board_endofturn()) {owgame->changeturn();}
					if (!owgame->checkgamewon()) {
						// Si es el turno de un jugador humano, recoge su input
						if ((owgame->selplayer_getaimode()==AI_HUMAN)&&(owgame->board_endofturn())) {
							if(owgame->MouseLeftButtonClicked(&mouse_x,&mouse_y)) {
								selected_cell = owgame->seleccionarcelda_bycoord(mouse_x,mouse_y);
								selected_cell.dir = 1; // fordward move
								if (owgame->selplayer_getboardside() == selected_cell.boardside) {
									cout << "move " << owgame->ow_commandline_translate_coord2name(selected_cell.boardside, selected_cell.x, selected_cell.y) << endl;	
									cout << "Sowing ... ";
									owgame->selplayer_makemovement(selected_cell.boardside, selected_cell.x,selected_cell.y);
								}
							}
							if (owgame->MouseRightButtonClicked(&mouse_x,&mouse_y)) {
								selected_cell = owgame->seleccionarcelda_bycoord(mouse_x,mouse_y);
								selected_cell.dir = -1; // reverse capture move
								if (owgame->selplayer_getboardside() == selected_cell.boardside) {
									cout << "rcapture " << owgame->ow_commandline_translate_coord2name(selected_cell.boardside, selected_cell.x, selected_cell.y) << endl;	
									cout << "Trying reverse capture ... ";
									owgame->selplayer_rcapture(selected_cell.boardside, selected_cell.x,selected_cell.y);
								}
							}
						}
					// End input de jugador humano

						if ((owgame->selplayer_getaimode()!=AI_HUMAN)&&(owgame->board_endofturn())) {
							selected_cell = owgame->selplayer_aimove(); 
							cout << "Selected move : " << (selected_cell.dir==1?"mv(":"rc(") << owgame->board_translate_coord2name(selected_cell.boardside, selected_cell.x, selected_cell.y) << ")" << endl;
							if (owgame->selplayer_aimove_found()) {
								if (owgame->selplayer_getboardside() == selected_cell.boardside) {
									if (selected_cell.dir==1) {
										cout << "Sowing ... ";
										owgame->selplayer_makemovement(selected_cell.boardside, selected_cell.x,selected_cell.y);
									} else {
										cout << "Reverse capture ... ";
										owgame->selplayer_rcapture(selected_cell.boardside, selected_cell.x,selected_cell.y);
									}
								}
							}
						}

					} //if !gamewon
					else { // if gamewon
						if (owgame->getnewgame_fromqueue()) {
							cout << "Running next game from queue ..." << endl;
							owgame->ow_commandline_showgameconfig(NULL);
						}
					}
				} // if gameplaying
			} // else settingup
		} // if gamecreated
		// Input del administrador
		owgame->commandline_read();

   } //if gamerunning
    
	//unload ow_game
	delete owgame;
  SDL_Quit();
}

void commandline_handler_wrapper(char *command) {
	owgame->commandline_parse_execute(command);
}
void commandline_handler_null(char *command) {
}

char **commandline_completion_handler(const char *text, int start, int end) {
	return owgame->commandline_completion(text,start,end);
}

char *commandline_command_generator(const char *text, int state) {
	return owgame->commandline_command_generator(text,state);
}

int commandline_savegames_filter(char **matches) {
	return owgame->commandline_savegames_filter(matches);
}
