#ifndef STDOMWESO_H
#define STDOMWESO_H

#ifndef DATADIR
#define DATADIR "."
#endif
#define DEFSTRINGIFY(x) #x
#define DEFTOSTRING(x) DEFSTRINGIFY(x)

#define DATAFOLDER(x)	DEFTOSTRING(DATADIR)"/"x


#define	AI_HUMAN							0
#define	AI_SIMPLE							1
#define	AI_NEGAMAX						2
#define AI_ALPHABETA					3
#define AI_SCOUT							4


#define AI_MAXDEPTH						15

#define AI_HUMAN_EVAL					0
#define AI_RANDOM_EVAL				1
#define AI_MATERIAL_EVAL			2
#define AI_DISPERSION_EVAL		3
#define AI_MOBILITY_EVAL			4
#define AI_REACH_EVAL					5


#define AI_F1COMB_EVAL			6
#define AI_F2COMB_EVAL			7


#define	PL_PLAYER1						0
#define	PL_PLAYER2						1

#define	CUR_WIDTH							46
#define	CUR_HEIGHT						60

#define	CELL_WIDTH						58
#define	CELL_HEIGHT						78
#define	CELL_BORDER						4
#define	CELL_SPACING					4

#define	CELL_STATUS_NORM			0
#define	CELL_STATUS_GREEN			1
#define	CELL_STATUS_RED				2
#define CELL_STATUS_CYAN			3

#define	CELL_ACTION_CANCEL		4
#define	CELL_ACTION_MOVEL			5
#define	CELL_ACTION_MOVER			6
#define	CELL_ACTION_SELECT		7
#define	CELL_ACTION_CAPTURE		8
#define	CELL_ACTION_PUT				9
#define	CELL_ACTION_TAKE			10
#define	CELL_ACTION_NONE			11

#define	BRD_NUM_SIDES					2
#define	BRD_ROWS_PER_PLAYER		2
#define	BRD_MAX_COLS_PER_PLAYER		8
#define	BRD_MAX_ROWS_PER_PLAYER		2
#define	BRD_SIDE_NORTH				0
#define	BRD_SIDE_SOUTH				1
#define BRD_INNER_ROW					0
#define BRD_OUTER_ROW					1


#define BRD_STATUS_READY				0
#define BRD_STATUS_SOWING				1
#define BRD_STATUS_ERRORMOVE		2
#define BRD_STATUS_CHAINMOVE		3
#define BRD_STATUS_CAPTURE			4
#define BRD_STATUS_REENTER_CAPTURE	5
#define BRD_STATUS_REVSOWING		6
#define BRD_STATUS_PCANNOTMOVE	7

#define BRD_SOWING_SPEED_USLOW	200
#define BRD_SOWING_SPEED_SLOW		135
#define BRD_SOWING_SPEED_NORM		75
#define BRD_SOWING_SPEED_FAST		30
#define BRD_SOWING_SPEED_ULTRA	0

#define BRD_MAX_UNDO_MOVES		150

#define	OWGFX_BACKGROUND			0
#define	OWGFX_CURSOR					1
#define	OWGFX_CELL						2
#define	OWGFX_PLAYERMARKER		0
#define	OWGFX_GAMEWON					1

#define OWINPUT_MOUSEDELAY		25 // 25 frames

#define OWGAME_MENU_APP				0
#define OWGAME_MENU_APP_NEWGAME		1
#define OWGAME_MENU_SETUPBOARD		2
#define OWGAME_MENU_PLY						3
#define OWGAME_MENU_MAI						4
#define OWGAME_MENU_BAT						5

#define OWGAME_MENU_APP_COMMANDS					10
#define OWGAME_MENU_APP_NEWGAME_COMMANDS	5
#define OWGAME_MENU_SETUPBOARD_COMMANDS		7
#define OWGAME_MENU_PLY_COMMANDS					8
#define OWGAME_MENU_MAI_COMMANDS					9
#define OWGAME_MENU_BAT_COMMANDS					9

#define OWGAME_STATUS_STOPPED			0
#define OWGAME_STATUS_RUNNING			1
#define OWGAME_STATUS_CREATED			2
#define OWGAME_STATUS_WON					3
#define OWGAME_STATUS_PLAYING			4

typedef struct {
	int x; int y;
	int boardside;
} cellXY;

typedef struct {
	int x; int y;
	int boardside;
	int dir; // 1:move -1:rcapture
} ow_move;

typedef struct {
	int x; int y;
	int boardside;
	int dir; // 1:move -1:rcapture
	int veval;
} ow_move_eval;

#endif

