/***************************************************************************
 *   Copyright (C) 2007 by David Torres   *
 *   aiken669@gmail.com   *
 ***************************************************************************/
#include "ow_aisearch.h"
#include "eval_functions.h"
#include <iostream>
using namespace std;

/**
* Creates a new ow_aisearch object width default values.
* @param owboard Pointer to the board used during the game, where to look for moves.
* @return New ow_aisearch object.
*/
ow_aisearch::ow_aisearch(ow_board *owboard)
{
	this->owboard = owboard;
}

/**
* Deletes the ow_aisearch object
*/
ow_aisearch::~ow_aisearch()
{
	//cout << "delete ow_aisearch base" << endl;
}

/**
* Virtual method implemented by derived clases.
* Starts or continues a search for the best position to move in that boardside.
* @param prinvar Principal variation found during the IA search.
* @param board Pointer to the board.
* @param boardside Side of the board where to look for best move.
* @param depth  Depth of the search algoritm
* @return -1 if not found yet, >=0 if best move found, also it is the max eval value.
*/
int ow_aisearch::search(ow_move prinvar[], ow_board *board, int boardside, int depth) {
	cout << "search base" << endl;
}

/**
* Sets the evaluation function to be used by the aisearch algoritm.
* @param idfunct Selected function id (AI_RANDOM_FUNC)
*/
void ow_aisearch::setevalfunc(int idfunct) {
	switch (idfunct) {
		// Simple functions
		case AI_RANDOM_EVAL: this->evalfunct = evalfunc_random; break;
		case AI_MATERIAL_EVAL: this->evalfunct = evalfunc_material; break;
		case AI_DISPERSION_EVAL: this->evalfunct = evalfunc_dispersion; break;
		case AI_MOBILITY_EVAL: this->evalfunct = evalfunc_mobility; break;
		case AI_REACH_EVAL: this->evalfunct = evalfunc_reachfront; break;
		// Combined functions
		case AI_F1COMB_EVAL: this->evalfunct = evalfunc_F1comb; break;
		case AI_F2COMB_EVAL: this->evalfunct = evalfunc_F1comb; break;

	}
}

