/***************************************************************************
 *   Copyright (C) 2007 by David Torres   *
 *   aiken669@gmail.com   *
 ***************************************************************************/
#include "ow_aisearch_simple.h"
#include "eval_functions.h"

#include <iostream>
#include <ctime>
using namespace std;

/**
* Creates a new ow_aisearch_simple object width default values.
* @param owboard Pointer to the board used during the game, where to look for moves.
* @return New ow_aisearch_simple object.
*/
ow_aisearch_simple::ow_aisearch_simple(ow_board *owboard)
 : ow_aisearch(owboard)
{
	this->owboard = owboard;
	this->evalfunct = evalfunc_random;
}

/**
* Deletes the ow_aisearch_simple object
*/
ow_aisearch_simple::~ow_aisearch_simple()
{
	//Carefull with this is virtual method, executes both this and parent, shit.
	//cout << "delete ow_aisearch_simple" << endl;
}

/**
* Starts or continues a search for the best position to move in that boardside.
* @param prinvar Principal variation found during the IA search.
* @param board Pointer to the board.
* @param boardside Side of the board where to look for best move.
* @param depth  Depth of the search algoritm
* @return -1 if not found yet, >=0 if best move found, also it is the max eval value.
*/
int ow_aisearch_simple::search(ow_move prinvar[], ow_board *board, int boardside, int depth) {
	int excount=0;
	int idxcol, idxrow; int val, bestvalue=-10001;
	ow_board *newboard;
//  cout << "search simple" << endl;
	cout << "Searching (simple) ...";
	srand((unsigned)time(0));
  //board->draw_txt();
	prinvar[0].boardside=-1;
	for (idxrow=0;idxrow<BRD_ROWS_PER_PLAYER;idxrow++) {
		for (idxcol=0; idxcol<(this->owboard->getcolcount());idxcol++) {
			newboard = new ow_board(this->owboard);
			if (newboard->move_d(boardside, idxcol, idxrow)!=-1) {excount++;
				val = this->evalfunct(newboard,boardside);
				if (val>bestvalue) {bestvalue=val;prinvar[0].x=idxcol;prinvar[0].y=idxrow;prinvar[0].boardside = boardside;prinvar[0].dir=1;}
			}
			delete newboard;
		}
	}

	prinvar[1].boardside=-1;prinvar[1].x=-1;prinvar[1].y=-1;
	//this->searching = 0; 
	cout << " Done." << endl; 
	return bestvalue;
}

