/***************************************************************************
 *   Copyright (C) 2007 by David Torres   *
 *   aiken669@gmail.com   *
 ***************************************************************************/
#ifndef STDOW_TABLERO_H
#define STDOW_TABLERO_H

#include <string>
#include <SDL/SDL.h>
#include <SDL/SDL_ttf.h>
#include "omweso.h"
#include "ow_cell.h"

using namespace std;

/**
	@author David Torres <aiken669@gmail.com>
*/

class ow_board{
private:
	int status;
	int brd_num_cols;
	int movecount, movecurrent;
	cellXY moveini;
	cellXY movestep;
	int sowing_delay, board_sowing_delay;
	int handseeds;
	int turnchains;
	int gfxdata_loaded;
  SDL_Surface *gfxdata[3];
  SDL_Palette *plt;
	TTF_Font *font;
	void display_errormove(int boardside, int cellx, int celly);
	int _move(int boardside, int cellx, int celly);
	void update_status_actions();
	int ntakeseeds(int seeds, int boardside, int cellx, int celly);
	int nputseeds(int seeds, int boardside, int cellx, int celly);
	
	int saveundo();int undo_active;
	int undodata[BRD_MAX_UNDO_MOVES][BRD_NUM_SIDES][BRD_MAX_COLS_PER_PLAYER][BRD_MAX_ROWS_PER_PLAYER];
	int backupsaved;
	int backupdata[BRD_NUM_SIDES][BRD_MAX_COLS_PER_PLAYER][BRD_MAX_ROWS_PER_PLAYER];

public:
  ow_cell *bcells[BRD_NUM_SIDES][BRD_MAX_COLS_PER_PLAYER][BRD_MAX_ROWS_PER_PLAYER]; 

  ow_board(int columns);
	ow_board(ow_board *board);

	void suggested_beginners_seeds_initial_setup();

  int load_gfxdata();
  SDL_Palette *get_palette();

  void draw_gfx(SDL_Surface *surface);
	void draw_txt();
	int move(int boardside, int cellx, int celly);
	int move_d(int boardside, int cellx, int celly);
	int rcapture(int boardside, int cellx, int celly);
	int rcapture_d(int boardside, int cellx, int celly);
	int capture();
	int takeseeds(int boardside, int cellx, int celly);
	int countseeds(int boardside, int cellx, int celly);
	int countseeds(int boardside);
	int initialboard_countseeds(int boardside, int cellx, int celly);
	int initialboard_reset();
	int initialboard_setcurrent();

	int bsetup_takeseeds(int seeds, int boardside, int cellx, int celly);
	int bsetup_putseeds(int seeds, int boardside, int cellx, int celly);

	int checkavailablemoves(int boardside);
	int checkmove(int boardside, int cellx, int celly);
	int checkrcapture(int boardside, int cellx, int celly);
	void set_undo_mode(int status);
	int undolastmove(int nummoves);

	int savebackup();
	int restorebackup();

	int endofturn();
	void clear_status_actions();
	int update_status();
	int getcolcount();
	int counthandseeds();
	int setcellseeds(int seeds, int boardside, int cellx, int celly);
	//int setcellstatus(int status, int boardside, int cellx, int celly);
	//int setcellaction(int action, int boardside, int cellx, int celly);
	void setboardspeed(int bspeed);
 	string translate_coord2name(int boardside, int cellx, int celly);

  ~ow_board();
};

#endif
