/***************************************************************************
 *   Copyright (C) 2007 by David Torres   *
 *   aiken669@gmail.com   *
 ***************************************************************************/
#ifndef OW_CELL_H
#define OW_CELL_H

#include <string>
#include <SDL/SDL.h>
#include <SDL/SDL_ttf.h>

using namespace std;
/**
	@author David Torres <aiken669@gmail.com>
*/

class ow_cell{
private:
	int x,y;
	string cellname;
	SDL_Surface *gfxdata;
	SDL_Surface *background;
	int cellstatus;
	int cellaction;
	int cellseeds;
	int statusaction_timeout;
public:
	ow_cell(int screenx, int screeny, int boardside, int cellx, int celly);

	int countseeds();
	void emptyseeds();
	int addseeds(int seeds);
	int takeseeds(int seeds);

	void setaction(int action, int timeout);
	void setstatus(int status, int timeout);
	void update_status_action();

	void set_gfxdata(SDL_Surface *gfxdat);
	void draw(SDL_Surface *surface, TTF_Font *font);

	cellXY getcellcoordXY();
	void setcellname(string newcellname);
	int isOverCoordXY(int coordx, int coordy);

	~ow_cell();

};

#endif
