/***************************************************************************
 *   Copyright (C) 2007 by David Torres   *
 *   aiken669@gmail.com   *
 ***************************************************************************/
#ifndef OW_PLAYER_H
#define OW_PLAYER_H

#include "ow_board.h"
#include "ow_aisearch.h"

/**
	@author David Torres <aiken669@gmail.com>
*/	

class ow_player{
private:
	ow_board *owboard;
	int playernum;
	char playername[32];
	int aimode, aidepth, aieval;
	int boardside;
	int sleep;
	ow_aisearch *aisearch;
	int searchfound;
public:
	cellXY selected_cell;

	ow_player(ow_board *owboard,  int playernum, int boardside);
	int makemovement(int boardside, int cellx, int celly);
	int rcapture(int boardside, int cellx, int celly);
	ow_move searchbestmove_ai();
	int foundbestmove_ai();
	int endofturn();

	void gosleep();
	void wakeup();

	int getplayernum();
	void setplayername(const char *pname);
	void setplayer_aimode(int aimode);
	void setplayer_aidepth(int depth);
	void setplayer_aieval(int aieval);
	char *getplayername();
	int getboardside();
	int getaimode();

	~ow_player();
};

#endif
